'use strict';
/*include jQuery*/
var $ = require('./../bower_components/jquery/dist/jquery');
window.jQuery = $;
/*include modernizr*/
require('browsernizr');

/*include angular*/
require('angular/angular');
var angularResource = require('./../bower_components/angular-resource/angular-resource');
var angularUiRouter = require('./../bower_components/angular-ui-router/release/angular-ui-router');

/*angular controller*/
var services = require('./services/services');
var controllers = require('./controllers/controllers');
var directives = require('./directives/directives');
var filters = require('./filters/filters');

/*angular configuration*/
angular.element(document).ready(function () {
    // smart works go here
    var $html = angular.element('html');
    angular.module('webApp', [
        'ui.router',
        'ngResource',
        'webControllers',
        'webFilters',
        'webServices',
        'webDirectives'
    ]).config(['$stateProvider', '$urlRouterProvider', '$interpolateProvider', '$provide',
        function($stateProvider, $urlRouterProvider, $interpolateProvider, $provide) {
            $stateProvider
                .state('home', {
                    url: '/',
                    templateUrl: 'partials/home-page.html',
                    controller: 'HomePageController'
                });

            $urlRouterProvider.otherwise('/');
            /* change configure to use [[ to be the interpolation */
            $interpolateProvider.startSymbol('[[');
            $interpolateProvider.endSymbol(']]');
            /* add safeApply function for $rootScope - called by $scope.$root.safeApply(fn) */
            $provide.decorator('$rootScope', [
                '$delegate',
                function($delegate) {
                    $delegate.safeApply = function(fn) {
                        var phase = $delegate.$$phase;
                        if (phase === '$apply' || phase === '$digest') {
                            if (fn && typeof fn === 'function') {
                                fn();
                            }
                        } else {
                            $delegate.$apply(fn);
                        }
                    };
                    return $delegate;
                }
            ]);
        }
    ]);
    // bootstrap model
    angular.bootstrap($html, ['webApp']);
});
